1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5# Fetch one or more remote refs and merge it/them into the current HEAD.
6
7USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
8LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
9SUBDIRECTORY_OK=Yes
10OPTIONS_SPEC=
11. git-sh-setup
12. git-sh-i18n
13set_reflog_action "pull${1+ $*}"
14require_work_tree_exists
15cd_to_toplevel
16
17
18die_conflict () {
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22Please, fix them up in the work tree, and then use 'git add/rm <file>'
23as appropriate to mark resolution, or use 'git commit -a'.")"
24 else
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
26 fi
27}
28
29die_merge () {
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32Please, commit your changes before you can merge.")"
33 else
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
35 fi
36}
37
38test -z "$(git ls-files -u)" || die_conflict
39test -f "$GIT_DIR/MERGE_HEAD" && die_merge
40
41strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
42log_arg= verbosity= progress= recurse_submodules=
43merge_args= edit=
44curr_branch=$(git symbolic-ref -q HEAD)
45curr_branch_short="${curr_branch#refs/heads/}"
46rebase=$(git config --bool branch.$curr_branch_short.rebase)
47if test -z "$rebase"
48then
49 rebase=$(git config --bool pull.rebase)
50fi
51dry_run=
52while :
53do
54 case "$1" in
55 -q|--quiet)
56 verbosity="$verbosity -q" ;;
57 -v|--verbose)
58 verbosity="$verbosity -v" ;;
59 --progress)
60 progress=--progress ;;
61 --no-progress)
62 progress=--no-progress ;;
63 -n|--no-stat|--no-summary)
64 diffstat=--no-stat ;;
65 --stat|--summary)
66 diffstat=--stat ;;
67 --log|--no-log)
68 log_arg=$1 ;;
69 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
70 no_commit=--no-commit ;;
71 --c|--co|--com|--comm|--commi|--commit)
72 no_commit=--commit ;;
73 -e|--edit)
74 edit=--edit ;;
75 --no-edit)
76 edit=--no-edit ;;
77 --sq|--squ|--squa|--squas|--squash)
78 squash=--squash ;;
79 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
80 squash=--no-squash ;;
81 --ff)
82 no_ff=--ff ;;
83 --no-ff)
84 no_ff=--no-ff ;;
85 --ff-only)
86 ff_only=--ff-only ;;
87 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
88 --strateg=*|--strategy=*|\
89 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
90 case "$#,$1" in
91 *,*=*)
92 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
93 1,*)
94 usage ;;
95 *)
96 strategy="$2"
97 shift ;;
98 esac
99 strategy_args="${strategy_args}-s $strategy "
100 ;;
101 -X*)
102 case "$#,$1" in
103 1,-X)
104 usage ;;
105 *,-X)
106 xx="-X $(git rev-parse --sq-quote "$2")"
107 shift ;;
108 *,*)
109 xx=$(git rev-parse --sq-quote "$1") ;;
110 esac
111 merge_args="$merge_args$xx "
112 ;;
113 -r|--r|--re|--reb|--reba|--rebas|--rebase)
114 rebase=true
115 ;;
116 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
117 rebase=false
118 ;;
119 --recurse-submodules)
120 recurse_submodules=--recurse-submodules
121 ;;
122 --recurse-submodules=*)
123 recurse_submodules="$1"
124 ;;
125 --no-recurse-submodules)
126 recurse_submodules=--no-recurse-submodules
127 ;;
128 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
129 dry_run=--dry-run
130 ;;
131 -h|--help-all)
132 usage
133 ;;
134 *)
135 # Pass thru anything that may be meant for fetch.
136 break
137 ;;
138 esac
139 shift
140done
141
142error_on_no_merge_candidates () {
143 exec >&2
144 for opt
145 do
146 case "$opt" in
147 -t|--t|--ta|--tag|--tags)
148 echo "Fetching tags only, you probably meant:"
149 echo " git fetch --tags"
150 exit 1
151 esac
152 done
153
154 if test true = "$rebase"
155 then
156 op_type=rebase
157 op_prep=against
158 else
159 op_type=merge
160 op_prep=with
161 fi
162
163 curr_branch=${curr_branch#refs/heads/}
164 upstream=$(git config "branch.$curr_branch.merge")
165 remote=$(git config "branch.$curr_branch.remote")
166
167 if [ $# -gt 1 ]; then
168 if [ "$rebase" = true ]; then
169 printf "There is no candidate for rebasing against "
170 else
171 printf "There are no candidates for merging "
172 fi
173 echo "among the refs that you just fetched."
174 echo "Generally this means that you provided a wildcard refspec which had no"
175 echo "matches on the remote end."
176 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
177 echo "You asked to pull from the remote '$1', but did not specify"
178 echo "a branch. Because this is not the default configured remote"
179 echo "for your current branch, you must specify a branch on the command line."
180 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
181 . git-parse-remote
182 error_on_missing_default_upstream "pull" $op_type $op_prep \
183 "git pull <remote> <branch>"
184 else
185 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
186 echo "from the remote, but no such ref was fetched."
187 fi
188 exit 1
189}
190
191test true = "$rebase" && {
192 if ! git rev-parse -q --verify HEAD >/dev/null
193 then
194 # On an unborn branch
195 if test -f "$GIT_DIR/index"
196 then
197 die "$(gettext "updating an unborn branch with changes added to the index")"
198 fi
199 else
200 require_clean_work_tree "pull with rebase" "Please commit or stash them."
201 fi
202 oldremoteref= &&
203 . git-parse-remote &&
204 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
205 oldremoteref="$(git rev-parse -q --verify "$remoteref")" &&
206 for reflog in $(git rev-list -g $remoteref 2>/dev/null)
207 do
208 if test "$reflog" = "$(git merge-base $reflog $curr_branch)"
209 then
210 oldremoteref="$reflog"
211 break
212 fi
213 done
214}
215orig_head=$(git rev-parse -q --verify HEAD)
216git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
217test -z "$dry_run" || exit 0
218
219curr_head=$(git rev-parse -q --verify HEAD)
220if test -n "$orig_head" && test "$curr_head" != "$orig_head"
221then
222 # The fetch involved updating the current branch.
223
224 # The working tree and the index file is still based on the
225 # $orig_head commit, but we are merging into $curr_head.
226 # First update the working tree to match $curr_head.
227
228 eval_gettextln "Warning: fetch updated the current branch head.
229Warning: fast-forwarding your working tree from
230Warning: commit \$orig_head." >&2
231 git update-index -q --refresh
232 git read-tree -u -m "$orig_head" "$curr_head" ||
233 die "$(eval_gettext "Cannot fast-forward your working tree.
234After making sure that you saved anything precious from
235$ git diff \$orig_head
236output, run
237$ git reset --hard
238to recover.")"
239
240fi
241
242merge_head=$(sed -e '/ not-for-merge /d' \
243 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
244 tr '\012' ' ')
245
246case "$merge_head" in
247'')
248 error_on_no_merge_candidates "$@"
249 ;;
250?*' '?*)
251 if test -z "$orig_head"
252 then
253 die "$(gettext "Cannot merge multiple branches into empty head")"
254 fi
255 if test true = "$rebase"
256 then
257 die "$(gettext "Cannot rebase onto multiple branches")"
258 fi
259 ;;
260esac
261
262if test -z "$orig_head"
263then
264 git update-ref -m "initial pull" HEAD $merge_head "$curr_head" &&
265 git read-tree -m -u HEAD || exit 1
266 exit
267fi
268
269if test true = "$rebase"
270then
271 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
272 if test "$oldremoteref" = "$o"
273 then
274 unset oldremoteref
275 fi
276fi
277
278merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
279case "$rebase" in
280true)
281 eval="git-rebase $diffstat $strategy_args $merge_args"
282 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
283 ;;
284*)
285 eval="git-merge $diffstat $no_commit $edit $squash $no_ff $ff_only"
286 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
287 eval="$eval \"\$merge_name\" HEAD $merge_head"
288 ;;
289esac
290eval "exec $eval"